<center><a href="sortd.c">Actual source code: sortd.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:18:51+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSC_DLL</font></strong>
<a name="line2">  2: </a><font color="#B22222">/*</font>
<a name="line3">  3: </a><font color="#B22222">   This file contains routines for sorting doubles.  Values are sorted in place.</font>
<a name="line4">  4: </a><font color="#B22222">   These are provided because the general sort routines incur a great deal</font>
<a name="line5">  5: </a><font color="#B22222">   of overhead in calling the comparision routines.</font>

<a name="line7">  7: </a><font color="#B22222"> */</font>
<a name="line8"> 8: </a> #include <A href="../../../include/petsc.h.html">petsc.h</A>
<a name="line9"> 9: </a> #include <A href="../../../include/petscsys.h.html">petscsys.h</A>

<a name="line11"> 11: </a><strong><font color="#228B22">#define SWAP(a,b,t) {t=a;a=b;b=t;}</font></strong>
<a name="line12"> 12: </a>
<a name="line15"> 15: </a><font color="#B22222">/* A simple version of quicksort; taken from Kernighan and Ritchie, page 87 */</font>
<a name="line16"> 16: </a><strong><font color="#4169E1"><a name="PetscSortReal_Private"></a>static <A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PetscSortReal_Private(<A href="../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *v,<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> right)</font></strong>
<a name="line17"> 17: </a>{
<a name="line18"> 18: </a>  <A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>  i,last;
<a name="line19"> 19: </a>  <A href="../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> vl,tmp;
<a name="line20"> 20: </a>
<a name="line22"> 22: </a>  <font color="#4169E1">if</font> (right &lt;= 1) {
<a name="line23"> 23: </a>    <font color="#4169E1">if</font> (right == 1) {
<a name="line24"> 24: </a>      <font color="#4169E1">if</font> (v[0] &gt; v[1]) SWAP(v[0],v[1],tmp);
<a name="line25"> 25: </a>    }
<a name="line26"> 26: </a>    <font color="#4169E1">return</font>(0);
<a name="line27"> 27: </a>  }
<a name="line28"> 28: </a>  SWAP(v[0],v[right/2],tmp);
<a name="line29"> 29: </a>  vl   = v[0];
<a name="line30"> 30: </a>  last = 0;
<a name="line31"> 31: </a>  <font color="#4169E1">for</font> (i=1; i&lt;=right; i++) {
<a name="line32"> 32: </a>    <font color="#4169E1">if</font> (v[i] &lt; vl) {last++; SWAP(v[last],v[i],tmp);}
<a name="line33"> 33: </a>  }
<a name="line34"> 34: </a>  SWAP(v[0],v[last],tmp);
<a name="line35"> 35: </a>  PetscSortReal_Private(v,last-1);
<a name="line36"> 36: </a>  PetscSortReal_Private(v+last+1,right-(last+1));
<a name="line37"> 37: </a>  <font color="#4169E1">return</font>(0);
<a name="line38"> 38: </a>}

<a name="line42"> 42: </a><font color="#B22222">/*@</font>
<a name="line43"> 43: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscSortReal.html#PetscSortReal">PetscSortReal</A> - Sorts an array of doubles in place in increasing order.</font>

<a name="line45"> 45: </a><font color="#B22222">   Not Collective</font>

<a name="line47"> 47: </a><font color="#B22222">   Input Parameters:</font>
<a name="line48"> 48: </a><font color="#B22222">+  n  - number of values</font>
<a name="line49"> 49: </a><font color="#B22222">-  v  - array of doubles</font>

<a name="line51"> 51: </a><font color="#B22222">   Level: intermediate</font>

<a name="line53"> 53: </a><font color="#B22222">   Concepts: sorting^doubles</font>

<a name="line55"> 55: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscSortInt.html#PetscSortInt">PetscSortInt</A>(), <A href="../../../docs/manualpages/Sys/PetscSortRealWithPermutation.html#PetscSortRealWithPermutation">PetscSortRealWithPermutation</A>()</font>
<a name="line56"> 56: </a><font color="#B22222">@*/</font>
<a name="line57"> 57: </a><strong><font color="#4169E1"><a name="PetscSortReal"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscSortReal.html#PetscSortReal">PetscSortReal</A>(<A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> n,<A href="../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> v[])</font></strong>
<a name="line58"> 58: </a>{
<a name="line59"> 59: </a>  <A href="../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>  j,k;
<a name="line60"> 60: </a>  <A href="../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> tmp,vk;

<a name="line63"> 63: </a>  <font color="#4169E1">if</font> (n&lt;8) {
<a name="line64"> 64: </a>    <font color="#4169E1">for</font> (k=0; k&lt;n; k++) {
<a name="line65"> 65: </a>      vk = v[k];
<a name="line66"> 66: </a>      <font color="#4169E1">for</font> (j=k+1; j&lt;n; j++) {
<a name="line67"> 67: </a>        <font color="#4169E1">if</font> (vk &gt; v[j]) {
<a name="line68"> 68: </a>          SWAP(v[k],v[j],tmp);
<a name="line69"> 69: </a>          vk = v[k];
<a name="line70"> 70: </a>        }
<a name="line71"> 71: </a>      }
<a name="line72"> 72: </a>    }
<a name="line73"> 73: </a>  } <font color="#4169E1">else</font> {
<a name="line74"> 74: </a>    PetscSortReal_Private(v,n-1);
<a name="line75"> 75: </a>  }
<a name="line76"> 76: </a>  <font color="#4169E1">return</font>(0);
<a name="line77"> 77: </a>}

</pre>
</body>

</html>
